var SRH = function () {
    this.id = "search_keyword";
    this.id_true = "search_keyword_true";
    this.id_userinput = "search_keyword_userinput";
    this.form_id = "form_Search";
    this.button = "btn_inputSearch";
    this.pop_id = "divSelect";
    this.type_prop_id = "search_keyword_type";
    this.action = "//" + fw.GetZhuDomain().replace("aws-", "") + (fw.getc_l_jyssearch() != "" ? "/" + fw.getc_l_jyssearch() :"") + "/search.html";
    this.tip = "输入公司名、监管号、IB名称等";
    this.domain = "//" + fw.GetZhuDomain().replace("aws-", "");
    this.defoult_img = "//osshead.fx960.com/headfoot/Content/images/zhida.png";
    this.getDataUrl = "//head.fx696.com/apidata/FindIntellisense_New";
    this.postStaticUrl = "//head.fx696.com/apidata/SearchTrader_New";
    this.getSearchAd = "//head.fx696.com/apidata/GetIntellisenseTip";
    this.AdText = "";
    this.AdCode = "";
    this.language = fw.language;
    this.country = fw.country;
    this.project = "0";
    this.obtp = (window.location.host.indexOf(fw.fxeyeurl()) > -1 ? "0" : "1");
    this.seletedIndex = -1;
}

SRH.prototype.IniteValue = function () {
    this.input = $("#" + this.id);
    this.buttom = $("#" + this.id);
    this.div = $("#" + this.pop_id);
    if ($("#" + this.id).attr("pld") != "") {
        this.tip = $("#" + this.id).attr("pld");
    }
    this.type_prop = ($("#" + this.id).attr(this.type_prop_id) != null ? $("#" + this.id).attr(this.type_prop_id) : "");

    this.mk = new Object();
    this.mk.maxtime = 300;
    this.mk.last_text = "";
    this.mk.now_text = "";
    this.mk.timer = 0;
    this.mk.needshow = false;
}

SRH.prototype.option = function () {
    return $("#" + this.pop_id + " ul li");
}

SRH.prototype.value = function () {
    return $("#" + this.id_true).val();
}

SRH.prototype.getData = function (value_input) {
    var _srh = this;

    if (value_input == null || value_input == "" || value_input == this.tip) {
        return false;
    }

    var search_url = _srh.getDataUrl + "?lang=" + _srh.language + "&countryCode=" + _srh.country + "&origin=" + this.getOrigin() + "&project=" + this.project + "&type=" + this.obtp + "&fuzzy=" + encodeURIComponent(value_input);

    $.get(search_url, "", function (ret) {
        _srh.div.find("ul").empty();
        var items = _srh.transData(ret.result, _srh.language, _srh.country);

        if (items != null && items.length > 0) {
            for (var k in items) {
                var item = items[k];
                _srh.CreateOptions(item, value_input, ret.result.tips);
            }
            _srh.div.show();
        }
        else {
            _srh.div.find("ul").empty();
            _srh.div.hide();
        }
    });
}

SRH.prototype.CreateOptions = function (item, value_input, tip) {
    var replaceValue = ''

    if (item.name != null && item.name != "") {
        var inputArr = item.name.match(new RegExp(value_input, 'ig'));
        if (inputArr != null && inputArr.length > 0) {
            replaceValue = inputArr[0];
        }
    }

    var li = new Object();
    li.link = (this.domain == "//www." + fw.wikifxurl() ? (this.domain + (this.language != null && this.language != "" ? "/" + this.language : "") + "/search.html?keyword={code}") : (this.domain + "/search.html?keyword={code}"));
    li.txt = this.get_item_tip(tip, item);

    var replaceText = item.name;
    if (replaceValue != '') {
        replaceText = item.name.replace(replaceValue, "<span class=\"antistop_txt\">" + replaceValue + "</span>");
    }

    var ul = $("#" + this.pop_id + " ul");
    var html = "";
    var opr = "";
    html += ("<a href=\"" + li.link.replace("{code}", encodeURIComponent(item.name)) + "\" " + opr + " target=\"_blank\">");
    html += ("<li data-text=\"" + item.name + "\" code=\"" + item.code + "\">");
    html += ("<img src=\"" + item.ico + "\" onerror=\"this.src = '" + this.defoult_img + "';\">" + replaceText + li.txt + "</li>");
    html += ("</a>");
    ul.append(html);
}

SRH.prototype.setInputValue = function (text, need) {
    $("#" + this.id).val(text);
    $("#" + this.id_true).val(text == this.tip ? "" : text);
    this.initHisInput();
}

//移动选中弹出框中的一项
SRH.prototype.SetOptions = function (index) {
    this.SetOptionsColor(index);
    this.SetOptionsText(index);
}

SRH.prototype.SetOptionsColor = function (index) {
    this.option().removeClass("on");
    this.option().eq(index).addClass("on");
}

SRH.prototype.SetOptionsText = function (index) {
    var text = this.option().eq(index).attr("data-text");
    this.setInputValue(text);
}

SRH.prototype.inite = function () {
    var _srh = this;

    this.IniteValue();

    if (this.input == null || this.input.length == 0) {
        return false;
    }

    this.input.on('focus', function () {
        if (($("#" + _srh.id).attr("AdText") == undefined || $("#" + _srh.id).attr("AdText") == "") && (_srh.value() == _srh.tip || _srh.value() == "")) {
            _srh.setInputValue("");
        }
        _srh.input.css("color", "#333");
        $("#txt_tip").hide();
    });

    this.input.on('blur', function () {
        if (_srh.value() == '') {
            _srh.setInputValue(_srh.tip);
            _srh.input.css("color", "#999");
            $("#txt_tip").show();
        }
        setTimeout(function () {
            _srh.div.hide();
            _srh.seletedIndex = -1;
        }, 200);
    });

    this.input.on('keyup', function (event) {
        if (event == undefined) {
            event = window.event;
        }

        var keyCode = event.keyCode || event.which || event.charCode;

        var real_input = true;

        switch (keyCode) {
            case 38:
                if (_srh.option().length > 0 && _srh.div.css("display") != "none") {
                    _srh.seletedIndex = (_srh.seletedIndex < 0 ? _srh.option().length - 1 : _srh.seletedIndex - 1);
                    _srh.SetOptions(_srh.seletedIndex);
                }

                real_input = false;
                break;
            case 40:
                if (_srh.option().length > 0 && _srh.div.css("display") != "none") {
                    _srh.seletedIndex = (_srh.seletedIndex >= _srh.option().length - 1 ? 0 : _srh.seletedIndex + 1);
                    _srh.SetOptions(_srh.seletedIndex);
                }

                real_input = false;
                break;
            case 13:
                if (_srh.value() != "") {
                    if ($("#divSelect ul li.on").length > 0) {
                        value = this.options[this.seletedIndex].getAttribute("data-text");
                    }
                    _srh.setInputValue(encodeURIComponent(value));
                }

                real_input = false;
                break;
        }

        if (real_input) {
            if ($("#" + _srh.id).val() == "" || $("#" + _srh.id).val() == _srh.tip) {
                $("#" + _srh.id_userinput).val("");
            }
            else {
                $("#" + _srh.id_userinput).val($("#" + _srh.id).val());
            }
        }
    });

    this.input.on('input propertychange', function () {
        var text = $("#" + _srh.id).val();
        $("#" + _srh.id_true).val(text == _srh.tip ? "" : text);
        if (_srh.value() != "" && _srh.value() != _srh.tip) {
            _srh.updateHisInput();
        }
        else {
            _srh.mk.needshow = false;
            _srh.mk.timer = _srh.mk.maxtime;
            _srh.mk.now_text = "";
            _srh.div.hide();
            _srh.div.find("ul").empty();
        }
    });

    $(document).on("click", "#" + this.button, function () {
        if (_srh.AdText != "" && _srh.AdCode != "" && $("#" + _srh.id).val() == _srh.AdText) {
            var lan_dealer = (_srh.domain == "//www." + fw.wikifxurl() ? (_srh.language != null && _srh.language != "" ? "/" + _srh.language : "") : "");
            window.open("https://" + fw.GetZhuDomain().replace("aws-", "") + lan_dealer + "/dealer/" + _srh.AdCode + ".html", "_blank");
            //window.open("https://" + fw.GetZhuDomain() + lan_dealer + "/search.html?keyword=" + _srh.AdText, "_blank");
            return false;
        }
        else if ($("#" + _srh.id).val() != '' && $("#" + _srh.id).val() != _srh.tip) {
            if ($("#" + _srh.button).attr("type") == "submit") {
                return;
            }
            else {
                window.open(_srh.action + "?keyword=" + encodeURIComponent(_srh.value()), "_blank");
            }
        }
        else {
            $("#" + _srh.id).focus();
        }
    });

    $(document).on("submit", "#" + this.form_id, function () {
        if (_srh.AdText != "" && _srh.AdCode != "" && $("#" + _srh.id).val() == _srh.AdText) {
            var lan_dealer = (_srh.domain == "//www." + fw.wikifxurl() ? (_srh.language != null && _srh.language != "" ? "/" + _srh.language : "") : "");
            window.open("https://" + fw.GetZhuDomain().replace("aws-", "") + lan_dealer + "/dealer/" + _srh.AdCode + ".html", "_blank");
            //window.open("https://" + fw.GetZhuDomain() + lan_dealer + "/search.html?keyword=" + _srh.AdText, "_blank");
            return false;
        }
        else if ($("#" + _srh.id).val() == _srh.tip || $("#" + _srh.id).val() == "") {
            return false;
        }
    });

    $(document).on("mousemove", "#" + this.pop_id + " ul li", function () {
        var index = $(this).index();
        _srh.SetOptionsColor();
        $(this).addClass("on");
        $(this).siblings().removeClass("on");
    });

    $(document).on("mouseleave", "#" + this.pop_id + " ul li", function () {
        $(this).removeClass("on");
    });

    this.delayInite();

    //定位弹层位置
    this.div.css({
        "top": this.div.prev().position().top + this.div.prev().height(),
        "left": this.div.prev().position().left,
        "width": this.div.prev().width()
    });

    //低版本ie(ie10,9,8,7,6)加遮罩
    var UA_ie = window.navigator.userAgent.toLowerCase();

    if (/msie\s8\.0/.test(UA_ie) != true && /msie\s7\.0/.test(UA_ie) != true) {
        document.addEventListener('visibilitychange', function () {
            _srh.div.hide();
            _srh.initHisInput();
        });
    }

    //点击其他区域时
    $(document).click(function (e) {
        var _con = $("#" + this.form_id + ",#" + this.form_id);
        if (!_con.is(e.target) && _con.has(e.target).length === 0) {
            _srh.div.hide();
            _srh.initHisInput();
        }
    });
}

SRH.prototype.delayInite = function () {
    var _srh = this;
    setInterval(function () {
        if (_srh.mk.timer <= 0 && _srh.mk.needshow) {
            _srh.mk.timer = 0;
            if (_srh.mk.now_text != _srh.mk.last_text) {
                _srh.getData(_srh.mk.now_text);
                _srh.mk.last_text = _srh.mk.now_text;
                _srh.mk.now_text = $.trim(_srh.value());
                _srh.mk.needshow = false;
                _srh.mk.timer = _srh.mk.maxtime;
            }
        }
        _srh.mk.timer = ((_srh.mk.timer < -99999 ? 0 : _srh.mk.timer) - 100);
    }, 100);
}

//终止感应计时
SRH.prototype.initHisInput = function () {
    this.mk.needshow = false;
    this.mk.last_text = $.trim($("#" + this.id_true).val());
    this.mk.now_text = $.trim($("#" + this.id_true).val());
    this.mk.timer = this.mk.maxtime;
}

SRH.prototype.updateHisInput = function () {
    this.mk.last_text = this.mk.now_text;
    this.mk.now_text = $.trim($("#" + this.id_true).val());
    this.mk.timer = this.mk.maxtime;
    this.mk.needshow = true;
}

SRH.prototype.transData = function (items, language, country) {
    if (items != null && items.Result != null) {
        var ret = new Array();
        for (var k in items.Result) {
            var info = new Object();
            info.code = items.Result[k].Code;
            info.ico = items.Result[k].Ico;
            info.name = items.Result[k].Name;
            info.type = items.Result[k].Type;
            info.project = items.Result[k].Project;

            ret.push(info);
        }

        return ret;
    }
}

SRH.prototype.getOrigin = function () {
    var origin = "";

    if (typeof fw != 'undefined' && typeof fw != undefined && fw != null) {
        origin = fw.getCookieFn("origin");
        if (origin == undefined || origin == "undefined" || origin == null) {
            return "";
        }
        else {
            return origin;
        }
    }
}

SRH.prototype.getUrlParamForSearch = function (name) {
    var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)"); //构造一个含有目标参数的正则表达式对象
    var r = window.location.search.substr(1).match(reg);  //匹配目标参数
    if (r != null) return unescape(r[2]); return null; //返回参数值
}

SRH.prototype.get_item_tip = function (tip, item) {
    if (tip != null && tip.length > 0) {
        for (var i = 0; i < tip.length; i++) {
            if (tip[i].project == item.project && tip[i].tp == item.type) {
                if (item.project == 1 && item.type == 1) {
                    return "<b class=\"jys-txt\">" + tip[i].name + "</b>";
                }
                else if (item.project == 1 && item.type == 2) {
                    return "<b class=\"dls-txt\">" + tip[i].name + "</b>";
                }
                else {
                    return "<b class=\"qkty-txt\">" + tip[i].name + "</b>";
                }
            }
        }
    }
    else {
        return "";
    }
}

window.SRH = SRH;

var sc = new SRH();
$("#form_Search").attr("action", sc.action).attr("target", "_blank");
sc.AdText = ($("#" + sc.id).attr("AdText") != null && $("#" + sc.id).attr("AdText") != "" ? $("#" + sc.id).attr("AdText") : "");
sc.AdCode = ($("#" + sc.id).attr("AdCode") != null && $("#" + sc.id).attr("AdCode") != "" ? $("#" + sc.id).attr("AdCode") : "");
sc.inite();

function PostSerchTongJi(code, txt_input, op, name, project, type) {
    var query = 1;
    if (typeof fw == 'undefined' || typeof fw == undefined || fw == null) {
        return true;
    }

    if (op == "1") {
        txt_input = $("#search_keyword_userinput").val();
        query = 0;
    }

    if (txt_input != null && txt_input != "" && txt_input != sc.tip) {
        try {
            var post_search_data = {
                "uid": (fw.getUserId() == "" ? "0" : fw.getUserId()),
                "agent": window.navigator.userAgent.toLowerCase(),
                "code": code,
                "name": name,
                "type": type,
                "project": project,
                "origin": fw.getCookieFn("origin"),
                "fuzzy": txt_input,
                "lang": fw.language,
                "country": fw.country,
                "domain": window.location.host,
                "clientId": fw.getCookieFn("fxeye_user_id"),
                "query": query
            }

            $.ajax({
                type: 'get',
                url: sc.postStaticUrl,
                data: post_search_data,
                success: function (data) {
                }
            });
        }
        catch (e) { }
    }
}

function getmainhost() {
    var curhost = window.location.host;
    if (curhost.indexOf(fw.fxeyeurl()) > -1) {
        return fw.fxeyeurl();
    }
    else {
        return fw.wikifxurl();
    }
}

var origin = sc.getUrlParamForSearch("origin");

if (origin != null && origin != "") {
    document.cookie = "origin=" + escape(origin) + ";path=/;domain=." + getmainhost();
}